#ifndef CarteSD_h
#define CarteSD_h

#include <Arduino.h>
#include <BaseComp.h>
#include <SdFat.h>
//#include <DS1307.h>
#include <DS3231.h>

//extern DS1307 rtc;
extern DS3231 rtc;
extern Time dT;
extern SdFat SD;
extern SdFile file;

class CarteSD {
private:
  boolean carteOK;
public:
	CarteSD() {
	  carteOK = false;
	}
  boolean init();
	boolean fichierExiste(String);
  boolean ouvreFichier(String, char);
  void ecritLigne(char);
  void ecritLigne(String);
  void ecritLigne(byte);
  void ecritLigne(int);
  void ecritLigne(long);
  void ecritLigne(float);
  void ecritLigne(double);
  String ecrit_Tc_Data(float dd[], byte);
  String ecrit_DT_Data(float dd[], byte);
	boolean donneesValides();
	void litLigne(char *);
	void litLigne(String *);
	void litLigne(float *);
	void litLigne(double *);
  void fermeFichier();
	void supprFichier(char *);
	String listeFchExt(String);
};

class InfoDH : public Editeur {
private:
	unsigned long tempsUNIX;
public:
	InfoDH(int, int, boolean, byte = 0);
	boolean majDH;
  void (*surDelai)(long); // pointeur sur une fonction d'action en cas d'activation du composant
	virtual void majValeur(String);
	virtual boolean select(int, int);
};

#endif