#ifndef Courbes_h
#define Courbes_h

#include <Arduino.h>
#include <BaseComp.h>

//float strToFloat(String s);
String floatToStr(float f);

class AffCourbes : public CompBase {
private:
  Editeur edtMinY;
  Editeur edtMaxY;
  Bouton fermer;
  String infosCrbs;
  String * nomCrb; // tableau de noms des courbes
  boolean debut;
  byte * pos; // positions des titres des courbes sur l'axe Y
	byte dTop; // dcalage de l'affichage par rapport au haut de l'cran
  byte lT; // nombre de caractres de infocCrbs
  long tPrec; // date de l'arrive du prcdent point (millisecondes)
  float pas; // espace horizontal sparant deux points  l'affichage
  float miniY, maxiY;
  float dT; // incrment de temps entre deux affichages
  long noPt; // index courant du point  afficher
  byte nbCrbs; // nombre de courbes
  int nbPtAff; // nombre de points affichs si celui-ci est infrieur au nombre max de points affichables
  int * axeH; // tableau des graduations horizontales
  int * axeV; // tableau des graduations verticales
  float * valH; // valeurs numriques affiches des graduations horizontales
  float * valV; // valeurs numriques affiches des graduations verticales  
  byte dH; // nombre de graduation horizontales
  byte dV; // nombre d graduations verticales
  float ** valC; // tableau de tableaux d'entiers
  float kA; // facteur d'chelle d'affichage
  int zA; // position du zro de l'affichage
  void affGrad(char); // affichage des valeurs des graduations
  byte ongletAppel; // mmorisation de l'onglet qui a appel AffCourbes
public:
  AffCourbes(byte, String, float, float, int);
  int nbPts; // nombre de points de chaque courbe
  int * clCrb; // tableau de couleurs des courbes
  float * ptCour; // tableau de points courants en entre
  void init();
  void minmaxY(float, float);
  virtual void affiche();
  void montre(float);
  void majAff(); // dessine le composant
  void efface();
  virtual boolean select(int sX, int sY);
};

#endif