#include <Arduino.h>
#include <BaseComp.h>
#include <DivComps.h>

void quickSort(int arr[], int left, int right) {
	int i = left, j = right;
	int tmp;
	int pivot = arr[(left + right) / 2];
/* partition */
	while (i <= j) {
		while (arr[i] < pivot)
			i++;
		while (arr[j] > pivot)
			j--;
		if (i <= j) {
			tmp = arr[i];
			arr[i] = arr[j];
			arr[j] = tmp;
			i++;
			j--;
		}
	};
/* recursion */
	if (left < j)
		quickSort(arr, left, j);
	if (i < right)
		quickSort(arr, i, right);
}

/*---------------------------------------------------------------*/
/*                           HORLOGE_PROG                           */
/*---------------------------------------------------------------*/
Horloge_Prog::Horloge_Prog(int a, int b, int c, int d, byte p) {
	tag = 0x08;
	centre_X = a; 
	centre_Y = b; 
	rayon_I = c; 
	rayon_E = d;
	rayon = 2+(rayon_I+rayon_E)/2; // rayon de traage des crans
	for (byte i = 0; i < 96; i++)
		cran[i] = 0;
	nbDep = 0;
	nbStop = 0;		
	marche = false;
	page = p;
	if (maSD.init()) {
	String strRegul = litStringSD();
		for (byte i = 0; i < 96; i++)
			cran[i] = byte(strRegul[i]-48);
	}
}

String Horloge_Prog::litStringSD() {
  String s = "";
  if (maSD.ouvreFichier("PgmRegul.txt", 'L')) {
    if (maSD.donneesValides())
      maSD.litLigne(& s);
  }
  maSD.fermeFichier();
  return s;
}

void Horloge_Prog::ecritStringSD(String s) {
  if (maSD.ouvreFichier("PgmRegul.txt", 'C')) { // si le fichier "ProgCour.txt" n'existe pas, il est cr
    maSD.ecritLigne(s); // on y crit la chane s
  }
  maSD.fermeFichier();
}

void Horloge_Prog::enrgProgCour() {
	for (byte i = 0; i < 96; i++)
	  strProg[i] = char(cran[i]+48);
	ecritStringSD(strProg);
}
void Horloge_Prog::affiche() {
	myGLCD.setColor(VGA_BLUE);
	for (int i = -180; i < 539; i++) { // trac des cercles de l'horloge
		float alpha = PI*i/360.0;
		for (int j = 1; j < 3; j++) {
			myGLCD.drawPixel(centre_X+(rayon_E+j)*cos(alpha), centre_Y+(rayon_E+j)*sin(alpha));
			myGLCD.drawPixel(centre_X+(rayon_I+j)*cos(alpha), centre_Y+(rayon_I+j)*sin(alpha));
		}
	}
	myGLCD.setBackColor(clFond);
	myGLCD.setColor(VGA_BLACK);
	for (int i = 0; i < 24; i++) {
		float alpha = PI*(90-15*i)/180;
		if (i > 6 && i <18) // affichage des heures
			myGLCD.print(String(i), centre_X+0.90*rayon_I*cos(alpha-0.1), centre_Y-0.90*rayon_I*sin(alpha-0.1), 180+15*i);
		else
			myGLCD.print(String(i), centre_X+0.97*rayon_I*cos(alpha), centre_Y-0.97*rayon_I*sin(alpha), 15*i);
	}
	for (int i = 0; i < 96; i++) {
		float alpha = (90-i*3.75)*PI/180;
		switch (cran[i]) {
			case 0:
				break;
			case 1:
				myGLCD.drawTransparentBitmap(centre_X+rayon*cos(alpha)-5, centre_Y-rayon*sin(alpha)-5, 10, 10, Red_C10);
				break;
			case 2:
				myGLCD.drawTransparentBitmap(centre_X+rayon*cos(alpha)-5, centre_Y-rayon*sin(alpha)-5, 10, 10, Blue_C10);
				break;
		}
	}
	traceProg();
}

void Horloge_Prog::razProg() {
	effaceProg();
  for (byte i = 0; i < 96; i++) 
    if (cran[i] != 0) {
			float angle = PI*(90-3.75*i)/180;
			myGLCD.drawTransparentBitmap(centre_X+rayon*cos(angle)-5, centre_Y-rayon*sin(angle)-5, 10, 10, Fond_C10);
			cran[i] = 0;
    }
	enrgProgCour();
}

void Horloge_Prog::effaceProg() { // efface le dessin d'une programmation, c'est--dire les crans et le trac entre crans
	myGLCD.setColor(clFond);
	for (byte i = 0; i < 96; i++) {
		if (cran[i] == 1) { // cran de dpart
			float aD = 90-3.75*i-3;
			for (byte j = i; j < 96+i; j++)
				if (cran[j%96] == 2) { // recherche du cran de stop suivant immdiatement le cran de dpart en cours
					float duree = 3.75*(i-j)+6;
					for (int k = -1; k < 2; k++)
						myGLCD.drawArc(centre_X, centre_Y, rayon+k, aD, duree);
					break;
				}
		}
	}
}

void Horloge_Prog::traceProg() {
			byte dep0 = 0;
			boolean vu = false;
			for (int i = 0; i < 96; i++) {
				if (cran[i] == 1) {
					nbDep = nbDep+1;
					if (! vu) {
						vu = true;
						dep0 = i;
					}
				}
				if (cran[i] == 2)
					nbStop = nbStop+1;
			}
			float aD, duree;
			myGLCD.setColor(VGA_RED);
			vu = false;			
			for (int i = dep0; i < 96+ dep0; i++) { // trac des priodes de chauffage
				if (cran[i % 96] == 1) {
					aD = 90-3.75*i;
					vu = true;
					duree = 0;
				}
				if (cran[i % 96] == 2) {
					for (int j = -1; j < 2 ; j++)
						myGLCD.drawArc(centre_X, centre_Y, rayon+j, aD-3, -(duree-6));
					vu = false;
					duree = 0;
				}
				if (vu)
					duree = duree+3.75;				
			}
}
  
boolean Horloge_Prog::select(int sX, int sY) {
	if (actif && visible) {
		int rS = sqrt(sq(sX-centre_X)+sq(sY-centre_Y));
		if (rS > rayon_I && rS < rayon_E) {
		  float angle = 3.75*round(180*atan2(centre_Y-sY, sX-centre_X)/(PI*3.75)); // angle trigonomtrique
			float alpha = 90-angle; // angle horaire
			if (alpha < 0)
				alpha = 360+alpha; // les angles vont de 0  360 
			angle = PI*angle/180.0;
			if (cran[round(alpha/3.75)] != 0) { // effaage d'un cran
				if (cran[round(alpha/3.75)] == 1) // prparation de l'tat du futur cran  crer
					marche = false;
				else
					marche = true;
				effaceProg();
				myGLCD.drawTransparentBitmap(centre_X+rayon*cos(angle)-5, centre_Y-rayon*sin(angle)-5, 10, 10, Fond_C10);
				cran[round(alpha/3.75)] = 0;
			}
			else { // marquage d'un cran
				if(! marche) {
					myGLCD.drawTransparentBitmap(centre_X+rayon*cos(angle)-5, centre_Y-rayon*sin(angle)-5, 10, 10, Red_C10);
					cran[round(alpha/3.75)] = 1; // indice du cran de dpart
				}
				else {
					myGLCD.drawTransparentBitmap(centre_X+rayon*cos(angle)-5, centre_Y-rayon*sin(angle)-5, 10, 10, Blue_C10);
					cran[round(alpha/3.75)] = 2; // indice du cran d'arrt
					nbStop = nbStop+1;
				}
				marche = ! marche;
			}
			traceProg();
			enrgProgCour();
			while (myTouch.dataAvailable()) // attend que l'appui sur l'cran cesse
				myTouch.read();
			if (surAppui != NULL)
				surAppui(marche); // fonction externe
			return true;
		}
	}
	else
		return false;
}

/*---------------------------------------------------------------*/
/*                                 BASSIN                                 */
/*---------------------------------------------------------------*/
Bassin::Bassin(int v, int cf, int pb) : edtDH(25, 30, false) {
	tag = 0xF0;
	cFond = cf;
	niveauPb = pb;
	clNiveau = VGA_BLACK;
  for (int i = 0; i < 256; i++)
    vague[i] = 70 * sin(8 * PI * i / 255);
	niveau = 0;
  nivPrec = -1000;
	tempEau = 20.0;
}

void Bassin:: affiche() {	// Dessine le bassin
  myGLCD.setColor(VGA_GREEN);
  myGLCD.fillRect(0, 90, 40, 100); // Bordure suprieure Gauche
  myGLCD.fillRect(280, 90, 319, 100); // Bordure suprieure Droite
  myGLCD.fillRect(22, 100, 31, 229); // Bord Gauche
  myGLCD.fillRect(288, 100, 297, 229); // Bord Droit
  myGLCD.fillRect(32, 230, 287, 239); // Fond du bassin
  myGLCD.fillCircle(32, 229, 11); // Raccord Bord Gauche -> Fond
  myGLCD.fillCircle(287, 229, 11); // Raccord Bord Droit -> Fond
  myGLCD.setColor(VGA_WHITE);
  myGLCD.fillRect(25, 131, 29, 133); // Marqueur Niveau Zro Gauche
  myGLCD.fillRect(290, 131, 294, 133); // Marqueur Niveau Zro Droit
	nivPrec = -1000;
	tempEauPrec = -1000;
	majNiveau(niveau);
	majTempEau(tempEau);
}

boolean Bassin::select(int sX, int sY) { // Dessine les vaguelettes en surface de l'eau
	float k;
  if (actif && visible) {
    int niv = trunc(niveau * kAff);
    for (int i = 0; i < 256; i++) {
      k = cos(2 * PI * j / 240)/10;
      j++;
      if (j == 240)
        j = 0;
      myGLCD.setColor(VGA_BLUE);
      myGLCD.drawLine(32 + i, 132 - niv + k * vague[i], 32 + i, 139 - niv);
      myGLCD.setColor(cFond);
      myGLCD.drawLine(32 + i, 125 - niv, 32 + i, 132 - niv + k * vague[i]);
    }
		majNiveau(niveau);
		majTempEau(tempEau);
  }
}

void Bassin::majNiveau(int niv) { // Dessine l'eau dans le bassin
  if (actif && visible) {
		if (niv != nivPrec) {
			String txt;
			niveau = niv;
			myGLCD.setColor(cFond);
			myGLCD.fillRect(32, 90, 32 + 255, 168); // Effaage niveau prcdent
			myGLCD.setColor(VGA_GREEN);
			myGLCD.fillRect(0, 90, 40, 100); // Retraage Bordure suprieure Gauche
			myGLCD.fillRect(280, 90, 319, 100); // Retraage Bordure suprieure Droite
			if (niveau > niveauPb) {
				niveau = niveauPb;
				clNiveau = VGA_RED;
				txt = F("anormal HAUT");
			} else
			if (niveau < -niveauPb) {
				niveau = -niveauPb;
				clNiveau = VGA_RED;
				txt = F("anormal BAS");
			} else {
				clNiveau = VGA_BLACK;
				txt = String(niveau)+" mm";
			}
			myGLCD.setColor(VGA_BLUE);
			myGLCD.fillRect(32, 140 - niveau * kAff, 32 + 255, 198);
			myGLCD.setColor(VGA_WHITE);
			myGLCD.fillRoundRect(60, 170, 260, 187);
			myGLCD.setColor(clNiveau);
			myGLCD.setBackColor(VGA_WHITE);
			myGLCD.print("Niveau Eau "+txt, CENTER, 175);
		}
		nivPrec = niveau;
	}
}

void Bassin::majTempEau(float tEau) {
  if (actif && visible) {
		if (tEau != tempEauPrec) {
			tempEau = tEau;
			myGLCD.setColor(VGA_BLUE);
			myGLCD.fillRect(32, 193, 32 + 255, 229);
			myGLCD.setColor(VGA_WHITE);
			myGLCD.fillRoundRect(60, 200, 260, 217);
			myGLCD.setColor(VGA_BLACK);
			myGLCD.setBackColor(VGA_WHITE);
			myGLCD.print("Temperature Eau "+String(tEau, 1)+" `C", CENTER, 205);
		}
		tempEauPrec = tEau;
	}
}

