#ifndef ServoM_h
#define ServoM_h

#include <Arduino.h>

#define T_MIN 400
#define T_MAX 2500

void initServoM();
void scruteServoM();
extern void (* surModif)(); // pointeur sur une fonction d'action

class ServoM; // Dclaation forward de la classe ServoM

struct PtrServoM {
  ServoM * ptrSM;
  PtrServoM * suiv;
  PtrServoM * ajoutServoM(ServoM * pt) {
    PtrServoM * nouvServoM = new PtrServoM;
    nouvServoM->ptrSM = pt;
    suiv = nouvServoM;
    return nouvServoM;
  }
};

extern byte nbServoM;
extern PtrServoM * servoM_Deb; // lment du dbut de la liste
extern PtrServoM * servoM_Cour; // pointeur d'lment de la liste

class ServoM {
  private:
  public:
		boolean vu;
		int8_t sens;
    byte pin;
    boolean actif;
    float duree;
		int dureeCmd;
		int tMax;
		int tMin;
		float incDuree;
    int angle;
		int vitesse;
		boolean finSeq;
    ServoM(byte p) {
      servoM_Cour = servoM_Cour->ajoutServoM(this); // inscription dans la liste chane de composants
      if (nbServoM == 0)
        servoM_Deb = servoM_Cour; // fixe un pointeur sur le dbut de la liste
      nbServoM++; // incrmente l'indice d'inscription dans le tableau des servoM's
      servoM_Cour->suiv = servoM_Deb; // Boucle le dernier pointeur sur le premier
      pin = p;
			tMin = T_MIN;
			tMax = T_MAX;
			finSeq = true;
			if (pin > 1 && pin < 8)
        DDRD |= (1 << pin);
      else if (pin < 14)
        DDRB |= (1 << (pin - 8));
    }
    void setTime(int);
    void setAngle(int, int = 0);
};

#endif