#ifndef BaseTemps_h
#define BaseTemps_h
#include <Arduino.h>

extern int indTemps;

class CompTemps; // dclaration forward de CompTemps

struct PtrTemps { // liste chane pour l'enregistrement des composants de squencement du temps
  CompTemps *ptrT; // lment CompBase
  PtrTemps *suiv; // pointeur sur le prochain lment de la liste
  PtrTemps *ajoutComp(CompTemps *pt) { // procdure d'ajout pour les composants CompTemps
    PtrTemps *nouvComp = new PtrTemps;
    nouvComp->ptrT = pt;
    nouvComp->suiv = suiv;
    suiv = nouvComp;
    return nouvComp;
  }
};

extern PtrTemps *debTemps;
extern PtrTemps *courTemps;

class CompTemps {
private :
  boolean affTi;
  long seuilTemps;
public:
  CompTemps(long t, boolean a, byte p = 0) { // constructeur
    courTemps = courTemps->ajoutComp(this); // inscription dans la liste chane de composants
    if (indTemps == 0)
      debTemps = courTemps; // fixe un pointeur sur le dbut de la liste	
    indTemps++; // incrmente l'indice d'inscription dans le tableau des composants
    surDelai = NULL;
	periode = t;
	affTi = false;
	seuilTemps = 0.95*t;
	actif = a;
	page = p;
  }
  void (*surDelai)(long); // pointeur sur une fonction d'action en cas d'activation du composant
  long periode;
  boolean actif;
  int page; // dans le cas d'utilisation avec des onglets, "onglet" doit tre gal  l'index de la page sur lequel est pos le composant
  virtual boolean select(long t);
};

#endif