#ifndef UTM-LatLon_h
#define UTM-LatLon_h

#include <Arduino.h>

extern float lat; // latitude en degrés écimaux
extern float lon; // longitude en degrés décimaux
extern float utm_N; // Northing en mètres
extern float utm_E; // Easting en mètres
extern String utm_Z; // zone

float toRadians(float); // Conversion de degrés dècimaux en radians

float toDegrees(float); // Conversion de radians en degrés décimaux

String dDecToDMS(float, boolean); // Conversion de degrés décimaux en degrés sexagésimaux
// float : l'angle en degrés décimaux
// boolean : si faux et que l'angle est négatif,, la valeur retournée est le complément à 360°

void LatLonVersUTM(float, float); // retourne la Zone, le Northing et l'Easting respectivement dans les variables utm_Z, utm_N et utm_E
// float : la Latitude en degrés décimaux
// float : la Longitude en degrés décimaux

void utmVersLatLon(float, float, String); // retourne la Latitude et la Longitude respecivement dans les variables Lat et Lon
// float :Easting en métres
// float :Northing en métres
// String : la Zone au format "T30" par exemple

#endif
