#include <BaseComp.h>
#include <BaseTemps.h>
#include <CarteSD.h>

unsigned long c = 0;
unsigned long d = 0;

extern unsigned int Ourson[0x12C0];
long scr24 = 0xF0F0C0; // Couleur de fond de l'écran (240, 240, 192 soit : 0xF798 en bmp565)
Pages mesPages("Boutons&Textes&Selecteurs&Autres", bmp24To16(scr24), 3);

/* Composants sur la page 0 (Boutons) */
Bouton btnSimple(20, 40, 120, 24, "Bouton simple", NULL, true);
Bouton btnIcone(20, 80, 180, 24, "Bouton avec icone", Drapeau, true);
Bouton btnFlipFlop(20, 120, 160,24, "Bouton Flip-Flop", NULL, false);

/* Composants sur la page 1 (Textes) */
Label info(20, 40, "Ceci est une information", VGA_BLUE, 1);
Label res(20, 80, "Longueur :", VGA_GREEN, 1);
Editeur hauteur(120, 72, 60, 24, "18.3 m", 0, 'D', true, 1);
Label valT(20, 120, "Entrez un nombre", VGA_BLACK, 1);
Editeur nombre(160, 112, 60, 24, "", 2, 'D', false, 1);

/* Composants sur la page 2 (Sélecteurs) */
BoiteListe unChoix(20, 40, 100,"Oiseaux&Mammiferes&Poissons&Reptiles", 'G', false, 2);
BoutonChoix btnC0(180, 40, "Banane", VGA_RED, 1, 0, 2);
BoutonChoix btnC1(180, 65, "Pomme", VGA_RED, 1, 1, 2);
BoutonChoix btnC2(180, 90, "Fraise", VGA_RED, 1, 2, 2);
BoutonChoix btnC3(180, 115, "Orange", VGA_RED, 1, 3, 2);
Marque maCoche(40, 160, "Vous pouvez cocher", VGA_BLUE, 2);

/* Composants sur la page 3 (Autres) */
Image ourson(40, 40, 80, 60, Ourson, 3);
Forme rct(35, 35, 89, 69, VGA_RED, 'R', 0, 3);
Message infoPage3;
InfoDH dateHeure(40, 200, false, 3);
Editeur cumulT(220, 200, 60, 24, "", 2, 'D', true, 3);
CompTemps nouvPoint(1000, true, 0);
Editeur cumulTi(220, 160, 60, 24, "", 2, 'D', true, 3);

void infoImage(boolean b) {
  infoPage3.affiche(String(freeRam()), 'I', 0);
}

void cumul(long b) {
  cumulT.affiche(String(c));
  c++;
}

void cumulTimer(long b) {
  cumulTi.affiche(String(d));
  d++;
  Serial.println(d);
}

int freeRam () {
  extern int __heap_start, *__brkval; 
  int v; 
  return (int) &v - (__brkval == 0 ? (int) &__heap_start : (int) __brkval); 
}

void appuiBtnSimple(boolean b) {
}


void setup() {
  Serial.begin(9600);
  defEcran(LANDSCAPE); // initialisation de l'afficheur en mode paysage
  ourson.surAppui = &infoImage;
  dateHeure.surDelai = &cumul;
  nouvPoint.surDelai = &cumulTimer;
  btnSimple.surAppui = &appuiBtnSimple;
}

void loop() {
  scruteEvent(); // fait tourner la boutique, c'est-à-dire scrute cycliquement si chacun des composants a quelque chose à faire
}
